import Raven from 'raven-js'
import * as T from '@/store/utils/types'
import { getCancelToken, setUserIdentifier } from '@/store/utils/api'
import { APP_CLASSES, API_USER_IDENTIFIER } from '@/store/utils/localStorageKeys'
import { SETTINGS_URL } from '@/store/utils/apiUrls'
import { post } from '@/store/utils/api'

export default {
  state: {
    accessTokens: [],
    appStatuses: {
      eshop: false,
    },
    currentVersion: '',
    appClasses: '',
    userIdentifier: sessionStorage.getItem(API_USER_IDENTIFIER) || '',
    appStatusInitialization: {},
    settingsConfig: {},
    shippingMethodHeight: 'auto',
  },
  actions: {
    setUserIdentifier({ commit }, identity) {
      let identifier = ''

      if (identity.value.indexOf(identity.type) === -1) {
        identifier = `${identity.type}-${identity.value}`
      } else {
        identifier = identity.value
      }

      commit(T.SET_USER_IDENTIFIER, identifier)
      return identifier
    },
    clearUserIdentifier({ commit }) {
      commit(T.SET_USER_IDENTIFIER, '')
    },
    async generateCancelToken({ state, commit, getters }, name) {
      getters.getCancelToken(name).forEach((token, index, object) => {
        object.splice(index, 1)
        token.cancel('System canceled duplicate request:' + name)
      })
      let cancelToken = getCancelToken()
      commit(T.SET_CANCEL_TOKEN, { name: name, token: cancelToken })
      return cancelToken
    },
    setAppStatus({ commit, getters }, status) {
      if (process.env.VUE_APP_LOG_SENTRY === 'true') {
        if (Object.values(status)[0] === true) {
          Raven.setExtraContext({
            app_context: Object.keys(status)[0],
          })
        } else if (Object.values(getters.getAllAppStatus).every(item => item === false)) {
          Raven.setExtraContext({
            app_context: 'dashboard',
          })
        }
      }
      commit(T.SET_APP_STATUS, status)
    },
    versionCheck({ commit, getters, dispatch }, data) {
      if (getters.getCurrentVersion !== data.version) {
        commit(T.SET_NEW_VERSION, data.version)
      }
      if (data.logout === true) {
        dispatch('logoutUser')
      }
    },
    isMobile() {
      let isMobile = false
      if (
        /(android|bb\d+|meego).+mobile|avantgo|bada\/|blackberry|blazer|compal|elaine|fennec|hiptop|iemobile|ip(hone|od)|ipad|iris|kindle|Android|Silk|lge |maemo|midp|mmp|netfront|opera m(ob|in)i|palm( os)?|phone|p(ixi|re)\/|plucker|pocket|psp|series(4|6)0|symbian|treo|up\.(browser|link)|vodafone|wap|windows (ce|phone)|xda|xiino/i.test(
          navigator.userAgent
        ) ||
        /1207|6310|6590|3gso|4thp|50[1-6]i|770s|802s|a wa|abac|ac(er|oo|s-)|ai(ko|rn)|al(av|ca|co)|amoi|an(ex|ny|yw)|aptu|ar(ch|go)|as(te|us)|attw|au(di|-m|r |s )|avan|be(ck|ll|nq)|bi(lb|rd)|bl(ac|az)|br(e|v)w|bumb|bw-(n|u)|c55\/|capi|ccwa|cdm-|cell|chtm|cldc|cmd-|co(mp|nd)|craw|da(it|ll|ng)|dbte|dc-s|devi|dica|dmob|do(c|p)o|ds(12|-d)|el(49|ai)|em(l2|ul)|er(ic|k0)|esl8|ez([4-7]0|os|wa|ze)|fetc|fly(-|_)|g1 u|g560|gene|gf-5|g-mo|go(\.w|od)|gr(ad|un)|haie|hcit|hd-(m|p|t)|hei-|hi(pt|ta)|hp( i|ip)|hs-c|ht(c(-| |_|a|g|p|s|t)|tp)|hu(aw|tc)|i-(20|go|ma)|i230|iac( |-|\/)|ibro|idea|ig01|ikom|im1k|inno|ipaq|iris|ja(t|v)a|jbro|jemu|jigs|kddi|keji|kgt( |\/)|klon|kpt |kwc-|kyo(c|k)|le(no|xi)|lg( g|\/(k|l|u)|50|54|-[a-w])|libw|lynx|m1-w|m3ga|m50\/|ma(te|ui|xo)|mc(01|21|ca)|m-cr|me(rc|ri)|mi(o8|oa|ts)|mmef|mo(01|02|bi|de|do|t(-| |o|v)|zz)|mt(50|p1|v )|mwbp|mywa|n10[0-2]|n20[2-3]|n30(0|2)|n50(0|2|5)|n7(0(0|1)|10)|ne((c|m)-|on|tf|wf|wg|wt)|nok(6|i)|nzph|o2im|op(ti|wv)|oran|owg1|p800|pan(a|d|t)|pdxg|pg(13|-([1-8]|c))|phil|pire|pl(ay|uc)|pn-2|po(ck|rt|se)|prox|psio|pt-g|qa-a|qc(07|12|21|32|60|-[2-7]|i-)|qtek|r380|r600|raks|rim9|ro(ve|zo)|s55\/|sa(ge|ma|mm|ms|ny|va)|sc(01|h-|oo|p-)|sdk\/|se(c(-|0|1)|47|mc|nd|ri)|sgh-|shar|sie(-|m)|sk-0|sl(45|id)|sm(al|ar|b3|it|t5)|so(ft|ny)|sp(01|h-|v-|v )|sy(01|mb)|t2(18|50)|t6(00|10|18)|ta(gt|lk)|tcl-|tdg-|tel(i|m)|tim-|t-mo|to(pl|sh)|ts(70|m-|m3|m5)|tx-9|up(\.b|g1|si)|utst|v400|v750|veri|vi(rg|te)|vk(40|5[0-3]|-v)|vm40|voda|vulc|vx(52|53|60|61|70|80|81|83|85|98)|w3c(-| )|webc|whit|wi(g |nc|nw)|wmlb|wonu|x700|yas-|your|zeto|zte-/i.test(
          navigator.userAgent.substr(0, 4)
        )
      ) {
        isMobile = true
      }
      return isMobile
    },
    getMobileDeviceType() {
      if (/(iPhone|iPad|iPod|iOS)/i.test(navigator.userAgent)) {
        return 'ios'
      } else if (/(Android)/i.test(navigator.userAgent)) {
        return 'android'
      } else {
        return 'others'
      }
    },
    setAppClasses({ commit, getters }, classes) {
      commit(T.SET_APP_CLASSES, classes.join(' '))
    },
    async loadBackendSetting({ commit, dispatch }, payload = []) {
      commit(T.PROCESSING_STARTED, 'loadingBackendSettings')
      return await post(SETTINGS_URL, { keys: payload })
        .then(response => {
          commit(T.SET_SETTINGS_CONFIG, response.data)
          return response.data
        })
        .catch(error => {
          dispatch('logError', { backendConfig: error.response.data })
        })
        .finally(() => {
          commit(T.PROCESSING_FINISHED, 'loadingBackendSettings')
        })
    },
    setShippingMethodBoxHeight: ({ commit, getters }, payload) => {
      if (payload > getters.getShippingMethodBoxHeight || typeof getters.getShippingMethodBoxHeight === 'string') {
        commit(T.SET_SHIPPING_METHOD_HEIGHT, payload)
      }
    },
  },
  mutations: {
    [T.SET_CANCEL_TOKEN]: (state, payload) => {
      if (typeof state.accessTokens[payload.name] === 'undefined') {
        state.accessTokens[payload.name] = []
      }
      state.accessTokens[payload.name].push(payload.token)
    },
    [T.SET_APP_STATUS]: (state, payload) => {
      state.appStatuses = { ...state.appStatuses, ...payload }
    },
    [T.SET_NEW_VERSION]: (state, version) => {
      state.currentVersion = version
    },
    [T.SET_APP_CLASSES]: (state, classes) => {
      state.appClasses = classes
      localStorage.setItem(APP_CLASSES, classes)
    },
    [T.SET_USER_IDENTIFIER]: (state, identity) => {
      state.userIdentifier = identity
      setUserIdentifier(identity)
    },
    [T.SET_SETTINGS_CONFIG]: (state, data) => {
      state.settingsConfig = { ...state.settingsConfig, ...data }
    },
    [T.SET_SHIPPING_METHOD_HEIGHT]: (state, payload) => {
      state.shippingMethodHeight = payload
    },
  },
  getters: {
    getCancelToken: state => name => {
      if (typeof state.accessTokens[name] === 'undefined') {
        return []
      }
      return state.accessTokens[name]
    },
    getAppStatus: state => name => {
      return state.appStatuses[name] || false
    },
    getAllAppStatus: state => {
      return state.appStatuses
    },
    getCurrentVersion: state => state.currentVersion,
    getUserIdentifier: state => state.userIdentifier,
    getBackendSetting: state => configKey => {
      return state.settingsConfig[configKey]
    },
    getShippingMethodBoxHeight: state => {
      return state.shippingMethodHeight
    },
  },
}
